--- /dev/null
+#!/bin/bash
+#
+# Author: Alan J. Pippin (apippin@pippins.net)
+# Date: 05/17/2009
+#
+ REV=1.0
+#
+# Description: This script wraps a number of linux utilities to
+# create a recipe for ripping protected DVDs, circumventing
+# ARcoSS and CRC checksum error protection schemes used on many
+# newer DVDs. Edit as appropriate for your needs. I use this to
+# backup DVDs I own, and do not condone any other activity it
+# may be used for.
+#
+# Known Issues/Limitations:
+# - Mirror mode is always done in ISO mode
+#
+# Package Dependencies:
+# lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
+#
+# Optional Dependencies:
+# lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
+#
+
+###############################################
+# Local Machine Settings - EDIT THIS SECTION
+
+# Specify the device path to the DVD drive
+dev=/dev/dvd2
+
+# Specify the path to the log directory
+logdir=/var/log/ripdvd
+
+# Specify the path to the tmp rip directory
+tmpdir=/myth/video/DVDs/.ripdvd
+
+# Specify the email address to send job notifications to
+mailto=ajp@pippins.net
+
+# Setup the path to the tools needed by this ripper
+PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
+
+# Use mplayer dumpstream to create the main VOB file
+# If set to 0, cat and other utils will be used to make it instead.
+# Using mplayer dumpstream is by far the best way to create the main VOB file
+# The only thing this doesn't work for are DVDs with the 99 title copy protection.
+# The script will autodetect these types of disks, and change this to 0 if necessary.
+# If this is set to 0, other methods will be employed to get the DVD VOB dump.
+use_mplayer_dumpstream=1
+
+# 2-channel AVI encoding audio bit rate
+audio_bitrate=224
+
+# If set to 1, this script will call another script to fill in the mythvideo metadata
+# If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
+# the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
+fill_mythvideo_metadata=1
+
+# If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
+# The autodetection may work, but it probably won't in this case. Set to 0 by default.
+# Override to 1 if you want the script to wing it, and hope it picks the right feature title.
+trust_feature_title_autodetect_when_uncertain=0
+
+###############################################
+# Command line processing
+typeset dvdname=""
+typeset debug=""
+typeset dest=""
+typeset isofile=""
+typeset -i keep_intermediate_files=0
+typeset -i make_final_dest_vob=0
+typeset -i make_final_dest_iso=0
+typeset -i make_final_dest_folder=0
+typeset -i make_final_dest_avi=0
+typeset -i errors=0
+typeset -i show_usage=0
+typeset -i mirror_mode=0
+typeset -i target_bitrate=0
+typeset -i target_size=0
+typeset -i audio_2ch=0
+typeset -i invalid_feature_title=0
+typeset -i feature_title_override=0
+typeset -i mplayer_dumpstream_incompatibility=0
+
+while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
+do
+ case $opt in
+ (n) dvdname=$OPTARG;;
+ (d) dest=$OPTARG;;
+ (b) target_bitrate=$OPTARG;;
+ (s) target_size=$OPTARG;;
+ (2) audio_2ch=1;;
+ (v) make_final_dest_vob=1;;
+ (i) make_final_dest_iso=1;;
+ (f) make_final_dest_folder=1;;
+ (x) make_final_dest_avi=1;;
+ (m) mirror_mode=1;;
+ (k) keep_intermediate_files=1;;
+ (t) feature_title_override=$OPTARG;;
+ (w) set -$opt;;
+ (h) show_usage=1;;
+ (:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
+ (\?) echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
+ esac
+done
+
+shift $((OPTIND-1))
+
+function usage() {
+ echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
+ echo >&2 "Revision $REV"
+ echo >&2 "Options:"
+ echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
+ echo >&2 " -n <dvdname> Specify what the name of the DVD is to process from $tmpdir"
+ echo >&2 " This is optional. If not specified, the dvd will be pulled from $dev"
+ echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
+ echo >&2 " The default operation is non-mirror mode where only the main"
+ echo >&2 " feature title will be ripped."
+ echo >&2 " -v Make the final image a DVD VOB file"
+ echo >&2 " -i Make the final image a DVD ISO file"
+ echo >&2 " -f Make the final image a DVD folder"
+ echo >&2 " -x Make the final image an AVI (XVID) file"
+ echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
+ echo >&2 " -s <size> Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
+ echo >&2 " -b <bitrate> Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"
+ echo >&2 " -2 Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
+ echo >&2 " -k Keep the intermediate files (good for debugging)"
+ echo >&2 " In -x mode, run with this option to keep the original .VOB file"
+ echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
+ echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
+ echo >&2 " -w Set the sh Execute/Verbose flag"
+ echo >&2 ""
+ exit 2
+}
+
+if (($errors)) || (($show_usage))
+then
+ usage
+fi
+
+# Sanity Check - Command Line Options
+if [ "$dest" == "" ]; then
+ echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
+ usage
+fi
+
+if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
+ echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
+ usage
+fi
+
+if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
+ echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
+ usage
+fi
+
+if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] &&
+ [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
+ echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
+ usage
+fi
+
+if [ $mirror_mode -eq 1 ]; then
+ if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] ||
+ [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
+ echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
+ usage
+ fi
+fi
+
+# Sanity Check - Key executables
+[[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
+[[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
+[[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
+[[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
+[[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
+[[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
+[[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
+[[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
+
+###############################################
+
+typeset -i ripdvd
+if [ -z "$dvdname" ]; then
+ # make sure the DVD device is accessible
+ volname $dev > /dev/null 2>&1
+ if [ $? != 0 ]; then
+ echo "-E- Can't access the DVD device $dev"
+ exit 1
+ fi
+ # now capture the volume name from the device
+ dvdname=`volname $dev | awk '{ print $1 }'`
+ ripdvd=1
+else
+ ripdvd=0
+fi
+
+# Make sure we have a non-empty dvdname
+if [ -z "$dvdname" ]; then
+ echo "-E- unable to determine dvdname"
+ exit 1
+fi
+
+# set up some variables to hold various logfiles
+logfile="$logdir/$dvdname.log"
+passlogfile="$tmpdir/divx2pass.log"
+ddrescuelog=`tempfile`
+dvdauthorlog=`tempfile`
+encodelog=`tempfile`
+dumplog=`tempfile`
+
+# create the tmpdir if it doesn't already exist
+if [ ! -d "$tmpdir" ]; then
+ mkdir -p "$tmpdir"
+ if [ $? != 0 ]; then
+ echo "-E- Unable to create the tmpdir: $tmpdir"
+ exit 1
+ fi
+fi
+
+# create the logdir if it doesn't already exist
+if [ ! -d "$logdir" ]; then
+ mkdir -p "$logdir"
+ if [ $? != 0 ]; then
+ echo "-E- Unable to create the logdir: $logdir"
+ exit 1
+ fi
+fi
+
+###############################################
+# cleanup functions
+cleanup() {
+ if [ $keep_intermediate_files -eq 0 ]; then
+ [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
+ [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
+ [[ -e "$encodelog" ]] && rm -f "$encodelog"
+ [[ -e "$dumplog" ]] && rm -f "$dumplog"
+ else
+ [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a $logfile
+ [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a $logfile
+ [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a $logfile
+ [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a $logfile
+ fi
+ echo ""
+}
+
+fatal_and_exit() {
+ if [[ -z "$1" ]]; then
+ msg="-E- control-c killed us"
+ else
+ msg=$1
+ fi
+ echo -e 2>&1 "$msg" | tee -a $logfile
+ if [[ -n "$mailto" ]]; then
+ echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
+ fi
+ exit 1
+}
+
+# Call our cleanup functions on INT and EXIT signals
+trap fatal_and_exit INT
+trap cleanup EXIT
+
+###############################################
+# processing functions
+function make_dvd_iso_image {
+ # load the CSS codes in the DVD drive
+ lsdvd $dev >> "$logfile"
+ if [ $? != 0 ]; then
+ fatal_and_exit "-E- lsdvd $dev failed"
+ fi
+
+ # read the DVD, ignoring/skipping CRC errors
+ isofile="$1"
+ ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
+ if [ $? != 0 ]; then
+ fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
+ fi
+ cat "$ddrescuelog" >> "$logfile"
+}
+
+function make_dvdbackup_folder_image {
+ # extract the feature title from the DVD image
+ echo "-> Extracting feature title using dvdbackup" | tee -a $logfile
+ [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
+ dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
+ if [ $? != 0 ]; then
+ fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
+ fi
+}
+
+function make_dvdauthor_folder_image {
+ # create a new DVD video of the feature title
+ echo "-> Creating DVD video $dest/$dvdname" | tee -a $logfile
+ [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
+ dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
+ cat $dvdauthorlog | grep -v "VOBU" >> $logfile
+
+ # There is a chance that dvdauthor won't like some of the VOBs.
+ # We can't tell ahead of time which ones it will choke on.
+ # So, we need to run it over and over again until it can process
+ # all the VOBs. If it can't handle one of them, run it through
+ # mencoder to fix it and try again. These errors are typically
+ # present due to the copy protection that ddrescue removed.
+ grep -q "SCR moves" $dvdauthorlog
+ while [ $? == 0 ]; do
+ # fix bad vobs that get the "SCR moves backwards" error:
+ # STAT: Processing VTS_01_0.VOB...
+ # ERR: SCR moves backwards, remultiplex input.
+ badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
+ if [[ ! -f "$badvob" ]]; then
+ fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
+ fi
+ echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a $logfile
+ cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> $logfile 2>&1
+ mv -f $badvob.fixed $badvob
+ echo "-> Creating DVD video $dest/$dvdname"
+ dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
+ cat $dvdauthorlog | grep -v "VOBU" >> $logfile
+ grep -q "SCR moves" $dvdauthorlog
+ done
+}
+
+function get_feature_title {
+ # if a feature title was given on the command line, use it
+ if [ $feature_title_override -ne 0 ]; then
+ feature_title=$feature_title_override
+ return 0
+ fi
+ # otherwise, use lsdvd to figure it out
+ if [ $ripdvd -eq 1 ]; then
+ feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
+ else
+ feature_title=`lsdvd "$isofile" | awk '/Longest/ { print $NF }'`
+ fi
+}
+
+function create_main_vob_with_cat {
+ # cd to the feature title DVD folder
+ pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
+ if [ $? != 0 ]; then
+ fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
+ fi
+
+ # concatenate all the VOBs together into 1 giant VOB
+ vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
+ cat $vobs > "$tmpdir/$dvdname.VOB"
+
+ # cd back to the dir we started from
+ popd > /dev/null 2>&1
+}
+
+function create_main_vob_with_mplayer {
+ # make sure we have a valid feature title
+ if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
+ fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
+ fi
+
+ # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
+ if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
+ msg="-E- We detected an mplayer dumpstream incompatibility earlier."
+ msg="$msg We also detected another condition that requires us to use dumpstream. "
+ msg="$msg\n Unable to rip this DVD in the mode you requested."
+ fatal_and_exit "$msg"
+ fi
+
+ # use mplayer to create the main VOB file
+ remove_dumplog=$1
+ echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $dest/$dvdname.VOB" | tee -a $logfile
+ echo " mplayer $lang_opts -dumpstream -dumpfile \"$dest/$dvdname.VOB\" -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> $logfile
+ mplayer $lang_opts -dumpstream -dumpfile "$dest/$dvdname.VOB" -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
+ if [ $? != 0 ]; then
+ cat $dumplog | grep -v "^A:" >> $logfile
+ fatal_and_exit "-E- Mplayer Failed"
+ fi
+ cat $dumplog | grep -v "^A:" >> $logfile
+ [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
+}
+
+function get_audio_id_from_iso {
+ # Adjust our audio ID to find the english audio stream
+ # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+ aidcheck=`tempfile`
+ aid=128
+ mplayer -v -endpos 0 -dvd-device "$isofile" dvd://$feature_title > $aidcheck 2>&1
+ grep -q "aid: $aid" $aidcheck
+ while [ $? == 1 ] && [ $aid -lt 159 ]; do
+ (( aid = aid + 1 ))
+ grep -q "aid: $aid" $aidcheck
+ done
+ [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+ echo "-> Setting the audio stream ID to $aid" | tee -a $logfile
+ # mencoder default DVD audio track language selection (english)
+ lang_opts="-aid $aid -alang en"
+}
+
+function get_crop_from_iso {
+ FRAMES=10000
+ echo "-> Detecting black frame border crop value from ISO file"
+ echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> $logfile
+ mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
+ [[ -e "md5sums" ]] && rm -f "md5sums"
+ CROP=`cat $dumplog | grep CROP | tail -1`
+ echo " Found crop value of $CROP" >> $logfile
+ CROP=${CROP#* crop=}
+ CROP=${CROP%%\).*}
+ typeset -i CROPCHECK
+ CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
+ echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> $logfile
+ if [ -z "$CROP" ]; then
+ fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
+ fi
+ if [ $CROPCHECK -lt 0 ]; then
+ CROP=""
+ else
+ CROP=",crop=$CROP"
+ fi
+ echo " Setting mencoder crop filter to: $CROP"
+}
+
+function get_audio_id_from_vob {
+ # Adjust our audio ID to find the english audio stream
+ # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+ aidcheck=`tempfile`
+ aid=128
+ mplayer -v -endpos 0 "$tmpdir/$dvdname.VOB" > $aidcheck 2>&1
+ grep -q "Found audio stream: $aid" $aidcheck
+ while [ $? == 1 ] && [ $aid -lt 159 ]; do
+ (( aid = aid + 1 ))
+ grep -q "Found audio stream: $aid" $aidcheck
+ done
+ [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+ echo "-> Setting the audio stream ID to $aid" | tee -a $logfile
+ # mencoder default DVD audio track language selection (english)
+ lang_opts="-aid $aid -alang en"
+}
+
+function check_vob_for_corrupted_start {
+ # check to see if the beginning of the DVD has a form of copy protection
+ # where they have deliberately broken the first X number of frames of the DVD.
+ # If we don't skip these, our resulting VOB file will not play.
+ badvobcheck=`tempfile`
+ endpos=360
+ skip=0
+ mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
+ if [ $? != 0 ]; then
+ fatal_and_exit "-E- Mencoder Failed"
+ fi
+ grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
+ while [ $? == 0 ] && [ $skip -lt $endpos ]; do
+ (( skip = skip + 5 ))
+ echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a $logfile
+ mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
+ if [ $? != 0 ]; then
+ fatal_and_exit "-E- Mencoder Failed"
+ fi
+ grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
+ done
+ [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
+
+ # cat the giant VOB into mencoder to create a playable VOB file
+ cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$dest/$dvdname.VOB" >> $logfile 2>&1
+ if [ $? != 0 ]; then
+ fatal_and_exit "-E- Mencoder Failed"
+ fi
+}
+
+function check_vob_for_completeness {
+ # check to make sure we got out a complete VOB.
+ # there is another kind of copy protection where the VOB's may
+ # have "MPG EOF" frames in the middle of the stream.
+ # this causes mencoder to not process the entire VOB, and exit without any errors.
+ # detect this by seeing how much smaller the dst vob is from the src vob.
+ MAX_FILESIZE_DELTA_PERCENT=70
+ SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
+ DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+ FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
+ if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
+ # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
+ echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a $logfile
+ create_main_vob_with_mplayer
+ [[ -e "$dumplog" ]] && rm -f $dumplog
+ DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+ FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
+ if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
+ fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
+ fi
+ fi
+}
+
+function check_vob_for_too_many_video_packets {
+ # If our earlier algorithm to work around this failed, throw an error.
+ # check to see if this DVD has a protection scheme we don't know how to work around
+ # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
+ # for some reason, the video is black, while the audio rolls, then the video finally comes
+ # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of
+ # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
+ # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
+ grep -q "Too many video packets in the buffer:" $logfile
+ if [ $? == 0 ]; then
+ # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
+ echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a $logfile
+ create_main_vob_with_mplayer
+ grep -q "Too many video packets in the buffer:" $dumplog
+ if [ $? == 0 ]; then
+ [[ -e "$dumplog" ]] && rm -f $dumplog
+ fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
+ fi
+ [[ -e "$dumplog" ]] && rm -f $dumplog
+ fi
+}
+
+function check_vob_for_a52_crc_errors {
+ # Let's see if we can playback our newly created VOB file without any errors.
+ # if there are issues, let's detect them now, and try to recreate the VOB
+ # there are some forms of copy protection that have missed above, that evidence
+ # themselves when we try to playback the VOB file. This was added to deal with
+ # the "a52: CRC check failed" copy protection scheme.
+ MAX_ERRORS=10
+ ENDPOS=120
+ echo "-> Checking for a52 audio stream CRC errors" | tee -a $logfile
+ mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+ cat $dumplog | grep -v "^A:" >> $logfile
+ errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
+ if [ $errors -gt $MAX_ERRORS ]; then
+ echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a $logfile
+ create_main_vob_with_mplayer
+ echo "-> Checking for a52 audio stream CRC errors" | tee -a $logfile
+ mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+ if [ $? != 0 ]; then
+ cat $dumplog | grep -v "^A:" >> $logfile
+ fatal_and_exit "-E- Mplayer Failed"
+ fi
+ cat $dumplog | grep -v "^A:" >> $logfile
+ errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
+ if [ $errors -gt $MAX_ERRORS ]; then
+ fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
+ fi
+ fi
+ [[ -e "$dumplog" ]] && rm -f $dumplog
+}
+
+function calculate_bitrate_from_target_size {
+ # determine what our bitrate needs to be if a target size was specified instead
+ if [ $target_size -ne 0 ]; then
+ vob_length=`mplayer -identify -v "$dest/$dvdname.VOB" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
+ ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
+ echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
+ fi
+}
+
+function create_dvdauthor_dvd_xml_file {
+ # make a dvdauthor xml menu file to create a valid DVD video from
+ # this script does a good job, but we'll still need to clean it up a bit after it runs
+ echo "-> Creating dvdauthor XML menu file" | tee -a $logfile
+ makexml -overwrite -dvd *.VOB -out dvd >> $logfile 2>&1
+ if [ $? != 0 ]; then
+ fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
+ fi
+
+ # replace the first line of the xml file to remove the bad dest path
+ awk -v line=1 -v new_content="<dvdauthor>" '{
+ if (NR == line) {
+ print new_content;
+ } else {
+ print $0;
+ }
+ }' dvd.xml > dvd.xml.new
+ mv -f dvd.xml.new dvd.xml
+ if [ $? != 0 ]; then
+ fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
+ fi
+
+ # remove the "<video " property line from the xml file
+ cat dvd.xml | grep -v "<video" > dvd.xml.new
+ mv -f dvd.xml.new dvd.xml
+ if [ $? != 0 ]; then
+ fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
+ fi
+
+ # remove the extra <pgc>..</pgc> pairs
+ cat dvd.xml | awk 'BEGIN {x=1}
+ {
+ if ($0~"</pgc>") {x=0}
+ if (x==1) {print $0}
+ if ($0~"<pgc>") {x=1}
+ }' > dvd.xml.new
+ echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
+ mv -f dvd.xml.new dvd.xml
+ if [ $? != 0 ]; then
+ fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
+ fi
+
+ # remove the VTS_*_0.VOB file as this is just the main menu video clip
+ cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
+ mv -f dvd.xml.new dvd.xml
+ if [ $? != 0 ]; then
+ fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
+ fi
+}
+
+function check_for_mplayer_dumpstream_incompatibility {
+
+ echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a $logfile
+
+ if [ ! -e "$dest/$dvdname.VOB" ]; then
+ # mplayer dumpstream does not work on DVDs that obscure the feature title.
+ # A DVD that has 99 titles, where the longest title isn't the main feature
+ # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
+ # out what the feature title is. This script will run through that flow if we
+ # set use_mplayer_dumpstream to 0. Check for this here.
+ if [ $ripdvd -eq 1 ]; then
+ lsdvd $dev | grep -q "Title: 99"
+ else
+ lsdvd "$isofile" | grep -q "Title: 99"
+ fi
+ # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
+ if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
+ if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
+ echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a $logfile
+ echo " You will need to determine this yourself and rerun the script with the -t option" | tee -a $logfile
+ invalid_feature_title=1
+ else
+ echo " Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a $logfile
+ echo "-W- We still may not be able to autodetect the right feature title" | tee -a $logfile
+ echo " You may need to determine this yourself and rerun the script with the -t option" | tee -a $logfile
+ use_mplayer_dumpstream=0
+ invalid_feature_title=1
+ fi
+ return
+ fi
+ fi
+
+ # There is another form of protection that causes the mplayer dumpstream to fail.
+ # This can be detected by telling mplayer to parse the VOB file by copying its audio
+ # video streams to a dummy output file (/dev/null). Do that here to check for that
+ # problem before continuing.
+ if [ -e "$dest/$dvdname.VOB" ]; then
+ mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
+ mencoder $mplayer_opts "$dest/$dvdname.VOB" -o "/dev/null" > $dumplog 2>&1
+ grep -q "Too many audio packets in the buffer" $dumplog
+ if [ $? == 0 ]; then
+ echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a $logfile
+ use_mplayer_dumpstream=0
+ mplayer_dumpstream_incompatibility=1
+ fi
+ [[ -e "$dumplog" ]] && rm -f $dumplog
+ fi
+}
+
+function fill_mythvideo_metadata {
+
+ # This function must be passed the filename as an argument
+ # The filename must be a full path to the file
+ filename="$1"
+
+ # Make sure the fill mythvideo metadata option has been set to 1
+ if [ $fill_mythvideo_metadata -eq 0 ]; then
+ echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a $logfile
+ return 0
+ fi
+
+ # If the fill mythvideo metadata script is present, run it
+ # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
+ if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
+ echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a $logfile
+ fill_mythvideo_metadata.pl -N 0 -F "$filename" >> $logfile 2>&1
+ else
+ echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a $logfile
+ echo " Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a $logfile
+ fi
+}
+
+function remove_intermediate_vob_file {
+ # remove the intermediate VOB file
+ if [ $keep_intermediate_files -eq 0 ]; then
+ [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
+ else
+ echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a $logfile
+ fi
+}
+
+function remove_intermediate_iso_file {
+ # remove the original DVD image
+ if [ $keep_intermediate_files -eq 0 ]; then
+ [[ -e "$isofile" ]] && rm "$isofile"
+ else
+ echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a $logfile
+ fi
+}
+
+function remove_intermediate_dvdbackup_folder {
+ if [ $keep_intermediate_files -eq 0 ]; then
+ [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
+ else
+ echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a $logfile
+ fi
+}
+
+###############################################
+# MAIN
+
+# Make a note of when this DVD rip started
+date=`date`
+echo -e "\n$date DVD rip started" >> "$logfile"
+
+# Rip the DVD - Mirror Mode
+if [ $mirror_mode -eq 1 ]; then
+ echo "-> Ripping DVD $dvdname to $dest"
+
+ # use ddrescue to make an ISO image of the disk
+ make_dvd_iso_image "$dest/$dvdname.iso"
+
+ # add this video data to the mythtv DB
+ fill_mythvideo_metadata "$dest/$dvdname.iso"
+
+ # eject the disk upon completion
+ eject -T $dev
+
+ date=`date`
+ echo "$date DVD rip completed" | tee -a $logfile
+
+ if [[ -n "$mailto" ]]; then
+ cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
+ fi
+
+fi
+
+# Rip the DVD - Main Title Feature Only
+if [ $mirror_mode -eq 0 ]; then
+
+ if [ $ripdvd -eq 1 ]; then
+ echo "-> Ripping DVD $dvdname to $dest" | tee -a $logfile
+
+ # use ddrescue to make an ISO image of the disk
+ make_dvd_iso_image "$tmpdir/$dvdname.iso"
+
+ fi
+
+ # make sure our isofile value is set
+ if [ -z "$isofile" ]; then
+ isofile="$tmpdir/$dvdname.iso"
+ fi
+
+ if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
+
+ if [ ! -e "$dest/$dvdname.VOB" ]; then
+ echo "-> Creating DVD video $dest/$dvdname.VOB" | tee -a $logfile
+
+ # get the feature title from the ISO
+ get_feature_title
+
+ # get the crop value from the ISO
+ get_crop_from_iso
+
+ # check for mplayer dumpstream incompatibilities
+ # if they exist, this method will set this mode to 0.
+ check_for_mplayer_dumpstream_incompatibility
+
+ if [ $use_mplayer_dumpstream -eq 1 ]; then
+
+ # get our audio id from the ISO file
+ get_audio_id_from_iso
+
+ # create our main VOB file from the ISO
+ create_main_vob_with_mplayer
+
+ # remove the intermediate VOB file
+ remove_intermediate_vob_file
+
+ # it's possible that our VOB is still corrupted in some manner
+ # check to make sure it is still a good VOB before continuing.
+ check_for_mplayer_dumpstream_incompatibility
+
+ fi
+
+ if [ $use_mplayer_dumpstream -eq 0 ]; then
+
+ # use dvdbackup to make a DVD folder of the feature title
+ make_dvdbackup_folder_image
+
+ # create our main VOB file
+ create_main_vob_with_cat
+
+ # get our audio id from the VOB file
+ get_audio_id_from_vob
+
+ # check for corrupted VOB start
+ check_vob_for_corrupted_start
+
+ # check to make sure our VOB is complete
+ check_vob_for_completeness
+
+ # check to make sure our VOB doesn't have too many video packets
+ check_vob_for_too_many_video_packets
+
+ # check to make sure our VOB doesn't have a52 crc errors
+ check_vob_for_a52_crc_errors
+
+ # remove the intermediate VOB file
+ remove_intermediate_vob_file
+
+ fi
+
+ # remove the intermediate ISO file
+ remove_intermediate_iso_file
+
+ else
+ echo "-> Skipping VOB creation. VOB DVD video already exists: $dest/$dvdname.VOB" | tee -a $logfile
+ fi
+
+ # transcode the DVD
+ if [ $make_final_dest_avi -eq 1 ]; then
+ echo "-> Encoding the DVD video to an AVI file" | tee -a $logfile
+
+ # determine what our bitrate needs to be if a target size was specified instead
+ calculate_bitrate_from_target_size
+
+ # There was a lot of experimentation to arrive at these values
+ # These seem to work OK for me. If they don't work for you, feel
+ # free to adjust/change as needed.
+
+ # Edit these as needed to suite your needs
+ mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
+ mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
+ mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
+ mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=2"
+
+ # There are a number of different ways to encode 6 channel audio.
+ # I've loaded 3 different ways into the mencoder_audioch_opts.
+ # It will cycle through them until it finds one that works.
+ # You can change the order to suit your needs.
+ if [ $audio_2ch -eq 0 ]; then
+
+ # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
+ #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
+ #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
+
+ # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
+ # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad
+ mencoder_audio_opts="-oac copy"
+
+ # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
+ mencoder_audioch_opts[0]="-channels 6 -af channels=6"
+ mencoder_audioch_opts[1]="-af channels=6"
+ mencoder_audioch_opts[2]=""
+
+ else
+ # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
+ mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+ mencoder_audioch_opts[0]=""
+ fi
+
+ # Do not edit this line. $mencoder_video_encoder_opts must be last
+ mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
+ mencoder_retval=0
+
+ for PASS in 1 2
+ do
+ # Set some options based on which pass we are in
+ mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
+ [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
+ [ $PASS -eq 1 ] && output_file="/dev/null"
+ [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
+
+ # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
+ for CH_OPTS in "${mencoder_audioch_opts[@]}";
+ do
+ echo -e " Encoding pass $PASS"
+ echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$dest/$dvdname.VOB\" -o \"$output_file\" >> $encodelog 2>&1" >> $logfile
+ mencoder $CH_OPTS $mencoder_opts_for_pass "$dest/$dvdname.VOB" -o "$output_file" > $encodelog 2>&1
+ mencoder_retval=$?
+ grep -q "\[channels\] Invalid" $encodelog
+ if [ $? != 0 ]; then
+ break;
+ else
+ echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> $logfile
+ fi
+ done
+ if [ $mencoder_retval != 0 ]; then
+ fatal_and_exit "-E- Unhandled mencoder error"
+ fi
+ # Concatenate the encode log to our main log file, greping out unwanted lines
+ cat $encodelog | grep -v "Pos:" >> $logfile
+ done
+
+ if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
+ [[ -e "$dest/$dvdname.VOB" ]] && rm -f "$dest/$dvdname.VOB";
+ [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
+ else
+ echo "-> Keeping VOB file: $dest/$dvdname.VOB" | tee -a $logfile
+ echo "-> Keeping mencoder 2pass logfile: $passlogfile"
+ fi
+ fi
+
+ # add this video data to the mythtv DB
+ [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi"
+ [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.VOB"
+
+ else
+
+ # use dvdbackup to make a DVD folder of the feature title
+ make_dvdbackup_folder_image
+
+ # cd to the feature title DVD folder
+ pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
+ if [ $? != 0 ]; then
+ fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
+ fi
+
+ # create the dvd.xml file for dvdauthor
+ create_dvdauthor_dvd_xml_file
+
+ # make the final DVD folder image
+ make_dvdauthor_folder_image
+
+ # add this video data to the mythtv DB
+ fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS"
+
+ # cd back to the dir we started from
+ popd > /dev/null 2>&1
+
+ if [ $make_final_dest_iso -eq 1 ]; then
+ echo "-> Creating ISO image of DVD video: $dest/$dvdname -> $dest/$dvdname.iso" | tee -a $logfile
+
+ # make an iso image out of our directory
+ mkisofs -dvd-video "$dest/$dvdname" 2>> $logfile | dd of="$dest/$dvdname.iso" obs=32k seek=0 > /dev/null
+ if [ $? != 0 ]; then
+ fatal_and_exit '-E- mkisofs -dvd-video "$dest/$dvdname" | dd of="$dest/$dvdname.iso" obs=32k seek=0 failed'
+ fi
+
+ # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
+ if [ -s "$dest/$dvdname.iso" ]; then
+ if [ $make_final_dest_folder -eq 0 ]; then
+ echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a $logfile
+ # remove the folder of the DVD image now that we have a .iso version of it
+ [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
+ fi
+ else
+ # we created an empty iso file, remove it
+ echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a $logfile
+ echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
+ [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
+ fi
+
+ # add this video data to the mythtv DB
+ fill_mythvideo_metadata "$dest/$dvdname.iso"
+
+ fi
+
+ fi
+
+ # remove the ddrescue DVD ISO image
+ remove_intermediate_iso_file
+
+ # remove the tmp dvdbackup folder of the DVD image
+ remove_intermediate_dvdbackup_folder
+
+ # eject the DVD disk upon completion
+ [ $ripdvd -eq 1 ] && eject -T $dev
+
+ date=`date`
+ echo "$date DVD rip completed" | tee -a $logfile
+
+ if [[ -n "$mailto" ]]; then
+ cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
+ fi
+
+fi
+